#ifndef _FLPYDSK_DRIVER_H
#define _FLPYDSK_DRIVER_H

#include "os.h"
#define DMA_BUFFER 0x1000 // start of dma tranfer buffer, end: 0x10000 (64KB border).
                          // It must be below 16MB = 0x1000000 and in identity mapped memory!

void flpydsk_initialize_dma();
void flpydsk_dma_read();
void flpydsk_dma_write();
unsigned char flpydsk_read_status ();
void flpydsk_write_dor( unsigned char val );
void flpydsk_send_command (unsigned char cmd);
unsigned char flpydsk_read_data();
void flpydsk_write_ccr(unsigned char val);
void flpydsk_wait_irq();
void i86_flpy_irq(struct regs* r);
void flpydsk_check_int(ULONG* st0, ULONG* cyl);
void flpydsk_control_motor(int b);
void flpydsk_drive_data(ULONG stepr, ULONG loadt, ULONG unloadt, int dma );
int flpydsk_calibrate(ULONG drive);
void flpydsk_disable_controller();
void flpydsk_enable_controller();
void flpydsk_reset();
int flpydsk_seek( ULONG cyl, ULONG head );
void flpydsk_lba_to_chs(int lba, int* head, int* track, int* sector);
void flpydsk_install(int irq);
void flpydsk_set_working_drive(unsigned char drive);
unsigned char flpydsk_get_working_drive();
void flpydsk_transfer_sector(unsigned char head, unsigned char track, unsigned char sector, unsigned char operation);
unsigned char* flpydsk_read_sector(int sectorLBA);
int flpydsk_write_sector(int sectorLBA);
void flpydsk_read_directory();

#endif
