#include "pci.h"

static ULONG pci_config_read(ULONG bus, ULONG device, ULONG func, ULONG reg)
{
    outportl(PCI_CONFIGURATION_ADDRESS,
        0x80000000
        | (bus    << 16)
        | (device << 11)
        | (func   <<  8)
        | (reg         ));
    return inportl(PCI_CONFIGURATION_DATA);
}

ULONG pci_config_read_32 (ULONG bus, ULONG device, ULONG func, ULONG reg)
{
    return pci_config_read(bus, device, func, reg);
}

USHORT pci_config_read_16 (ULONG bus, ULONG device, ULONG func, ULONG reg)
{
    return pci_config_read(bus, device, func, reg) & 0xffff;
}

unsigned char pci_config_read_8 (ULONG bus, ULONG device, ULONG func, ULONG reg)
{
    return pci_config_read(bus, device, func, reg) & 0xff;
}
